﻿using DumpTruck.DrawningObjects;
using DumpTruck.Generics;
using DumpTruck.MovementStrategy;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using DumpTruck.MovementStrategy;
using DumpTruck.DrawningObjects;
using DumpTruck.Generics;


namespace DumpTruck
{
    public partial class FormCarCollection : Form
    {
       
        private readonly CarsGenericStorage _storage;
        public FormCarCollection()
        {
            InitializeComponent();
            _storage = new CarsGenericStorage(pictureBoxCollection.Width,
pictureBoxCollection.Height);
        }

        private void ReloadObjects()
        {
            int index = listBoxStorages.SelectedIndex;
            
            listBoxStorages.Items.Clear();
            for (int i = 0; i < _storage.Keys.Count; i++)
            {
                listBoxStorages.Items.Add(_storage.Keys[i]);             
            }
           
            if (listBoxStorages.Items.Count > 0 && (index == -1 || index
            >= listBoxStorages.Items.Count))
            {
                listBoxStorages.SelectedIndex = 0;
            }
            else if (listBoxStorages.Items.Count > 0 && index > -1 &&
            index < listBoxStorages.Items.Count)
            {
                listBoxStorages.SelectedIndex = index;
            }
        }


        private void ButtonAddCar_Click(object sender, EventArgs e)
        {
            if (listBoxStorages.SelectedIndex == -1)
            {
                return;
            }
            var obj = _storage[listBoxStorages.SelectedItem.ToString() ?? string.Empty];

            if (obj == null)
            {

                return;
            }


            FormCarConfig form = new FormCarConfig();
            form.Show();
            Action<DrawningCar>? carDelegate = new((m) =>
            {
                int q = obj + m;

                if (q != -1)
                {
                    MessageBox.Show("Объект добавлен");
                    pictureBoxCollection.Image = obj.ShowCars();
                }
                else
                {
                    MessageBox.Show("Не удалось добавить объект");
                }
            });

            Action<Color>? ColorDelegate = new((m) =>
            {
                MessageBox.Show(m.ToString());
            });
            form.AddEvent(carDelegate);

        }

        private void ButtonRemoveCar_Click(object sender, EventArgs e)
        {
            if (listBoxStorages.SelectedIndex == -1)
            {
                return;
            }
            var obj = _storage[listBoxStorages.SelectedItem.ToString() ??
            string.Empty];
            if (obj == null)
            {
                return;
            }
            if (MessageBox.Show("Удалить объект?", "Удаление",
            MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.No)
            {
                return;
            }
            int pos = Convert.ToInt32(maskedTextBoxNumber.Text);
            if (obj - pos != null)
            {
                MessageBox.Show("Объект удален");
                pictureBoxCollection.Image = obj.ShowCars();
            }
            else
            {
                MessageBox.Show("Не удалось удалить объект");
            }

        }

        private void ButtonRefreshCollection_Click(object sender, EventArgs e)
        {
            if (listBoxStorages.SelectedIndex == -1)
            {
                return;
            }
            var obj = _storage[listBoxStorages.SelectedItem.ToString() ??
            string.Empty];
            if (obj == null)
            {
                return;
            }
            pictureBoxCollection.Image = obj.ShowCars();
        }

        private void maskedTextBoxNumber_MaskInputRejected(object sender, MaskInputRejectedEventArgs e)
        {

        }

        private void ButtonAddObject_Click(object sender, EventArgs e)
        {
            if (string.IsNullOrEmpty(textBoxStorageName.Text))
            {
                MessageBox.Show("Не все данные заполнены", "Ошибка",
                MessageBoxButtons.OK, MessageBoxIcon.Error);
                return;
            }
           
            _storage.AddSet(textBoxStorageName.Text);
            ReloadObjects();
        }

        private void ListBoxObjects_SelectedIndexChanged(object sender, EventArgs e)
        {
            
                pictureBoxCollection.Image =
                _storage[listBoxStorages.SelectedItem?.ToString() ?? string.Empty]?.ShowCars();
        }

        private void ButtonDelObject__Click(object sender, EventArgs e)
        {
            if (listBoxStorages.SelectedIndex == -1)
            {
                return;
            }
            if (MessageBox.Show($"Удалить объект { listBoxStorages.SelectedItem}?", "Удаление", MessageBoxButtons.YesNo,
MessageBoxIcon.Question) == DialogResult.Yes)
{
                _storage.DelSet(listBoxStorages.SelectedItem.ToString()
                ?? string.Empty);
                ReloadObjects();
            }

        }

        private void textBoxStorageName_TextChanged(object sender, EventArgs e)
        {

        }
    }
}

