﻿using DumpTruck.DrawningObjects;
using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace DumpTruck
{
    public partial class FormCarConfig : Form
    {
        
        DrawningCar? _car = null;
        public event Action<DrawningCar>? EventAddCar;

        public FormCarConfig()
        {
            InitializeComponent();
            panelBlack.MouseDown += PanelColor_MouseDown;
            panelPurple.MouseDown += PanelColor_MouseDown;
            panelOrange.MouseDown += PanelColor_MouseDown;
            panelLightBlue.MouseDown += PanelColor_MouseDown;
            panelWhite.MouseDown += PanelColor_MouseDown;
            panelYellow.MouseDown += PanelColor_MouseDown;
            panelBlue.MouseDown += PanelColor_MouseDown;
            panelRed.MouseDown += PanelColor_MouseDown;
            buttonCanel.Click += (s, e) => Close();
        }

        private void DrawCar()
        {
            Bitmap bmp = new(pictureBoxObject.Width, pictureBoxObject.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _car?.SetPosition(5, 5);
            _car?.DrawTransport(gr);
            pictureBoxObject.Image = bmp;
        }

        private void PanelColor_MouseDown(object sender, MouseEventArgs e)
        {
            (sender as Panel)?.DoDragDrop((sender as Panel)?.BackColor,
DragDropEffects.Move | DragDropEffects.Copy);
           
        }
        private void LabelColor_DragEnter(object sender, DragEventArgs e)
        {          
            if (e.Data.GetDataPresent(typeof(Color)))
                e.Effect = DragDropEffects.Copy;
            else
            {
                e.Effect = DragDropEffects.None;
            }
        }

        private void LabelColor_DragDrop(object sender, DragEventArgs e)
        {
                {
                    string senderName = ((Label)sender).Name;
                    if (_car == null || e.Data.GetDataPresent(typeof(Color)) == false)
                        return;

                    Color droppedColor = (Color)e.Data.GetData(typeof(Color));

                    if (senderName == "labelColor")
                    {
                        labelColor.BackColor = droppedColor;
                        ((DrawningCar)_car).setColor(labelColor.BackColor);
                    }
                    else if (senderName == "labelAddColor" && _car is DrawningDumpTruck)
                    {
                        labelAddColor.BackColor = droppedColor;
                        ((DrawningDumpTruck)_car).setAddColor(labelAddColor.BackColor);
                    }

                    DrawCar();
                }
        }

        private void LabelObject_MouseDown(object sender, MouseEventArgs e)
        {
            (sender as Label)?.DoDragDrop((sender as Label)?.Name,
DragDropEffects.Move | DragDropEffects.Copy);

        }

        private void PanelObject_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data?.GetDataPresent(DataFormats.Text) ?? false)
            {
                e.Effect = DragDropEffects.Copy;
            }
            else
            {
                e.Effect = DragDropEffects.None;
            }

        }

        private void PanelObject_DragDrop(object sender, DragEventArgs e)
        {
            switch (e.Data?.GetData(DataFormats.Text).ToString())
            {
                case "labelBaseObject":
                    _car = new DrawningCar((int)numericUpDownSpeed.Value,
                   (int)numericUpDownWeight.Value, Color.White, pictureBoxObject.Width,
                   pictureBoxObject.Height);
                    labelColor.BackColor = Color.White;
                    labelAddColor.BackColor = Color.Transparent;
                    break;
                case "labelAdvancedObject":
                    _car = new DrawningDumpTruck((int)numericUpDownSpeed.Value,
                   (int)numericUpDownWeight.Value, Color.White, Color.Black, checkBoxKit.Checked,
                   checkBoxTent.Checked, pictureBoxObject.Width,
                   pictureBoxObject.Height);
                    labelColor.BackColor = Color.White;
                    labelAddColor.BackColor = Color.Black;
                    break;
            }
            
            DrawCar();
        }

        public void AddEvent(Action<DrawningCar> ev)
        {
            if (EventAddCar == null)
            {
                EventAddCar = ev;
            }
            else
            {
                EventAddCar += ev;
            }
        }

        private void buttonAdd_Click(object sender, EventArgs e)
        {
            if (_car == null)
            {
                return;
            }
            EventAddCar?.Invoke(_car);
            Close();
        }
    }
}
