﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms.VisualStyles;

namespace DumpTruck.Generics
{
    internal class SetGeneric<T>
        where T : class
 
    {
        /// <summary>
        /// Массив объектов, которые храним
        /// </summary>
        private readonly List<T?> _places;
        /// <summary>
        /// Количество объектов в массиве
        /// </summary>
        public int Count => _places.Count;
        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="count"></param>
        /// 
        public int startPointer = 0;

        public int countMax = 0;
        public SetGeneric(int count)
        {
            _places = new List<T?>(count);
            countMax = count;
        }
        /// <summary>
        /// Добавление объекта в набор
        /// </summary>
        /// <param name="car">Добавляемый автомобиль</param>
        /// <returns></returns>
        public int Insert(T car)
        {
            
            if (_places.Count == countMax) { return -1; }
            
            return Insert(car, 0);
        }
        /// <summary>
        /// Добавление объекта в набор на конкретную позицию
        /// </summary>
        /// <param name="car">Добавляемый автомобиль</param>
        /// <param name="position">Позиция</param>
        /// <returns></returns>
        public int Insert(T car, int position)
        {

            if (!(position >= 0 && position <= Count && _places.Count < countMax))
            {
                return -1;
            }

            _places.Insert(position, car);
            return position;
        }
            // TODO проверка, что элемент массива по этой позиции пустой, если нет, то
            // проверка, что после вставляемого элемента в массиве есть пустой элемент
            // сдвиг всех объектов, находящихся справа от позиции до первого пустого элемента
            // TODO вставка по позиции

            
        
        /// <summary>
        /// Удаление объекта из набора с конкретной позиции
        /// </summary>
        /// <param name="position"></param>
        /// <returns></returns>
        public bool Remove(int position)
        {
            if (position < Count && position >= 0)
            {
                _places[position] = null;
                return true;
            }
            return false;
                
                
        }

        /// <summary>
        /// Получение объекта из набора по позиции
        /// </summary>
        /// <param name="position"></param>
        /// <returns></returns>
        public T? this[int position]
        {
            get {
                if (!(position >= 0 && position <= Count))
                    return null;
                return _places[position];
            }
            set
            {
                if (!(position >= 0 && position <= Count))
                    return;
                _places.Insert(position, value);
            }
        }
        /// <summary>
        /// Проход по списку
        /// </summary>
        /// <returns></returns>
        public IEnumerable<T?> GetCars(int? maxCars = null)
        {
            for (int i = 0; i < _places.Count; ++i)
            {
                yield return _places[i];
                if (maxCars.HasValue && i == maxCars.Value)
                {
                    yield break;
                }
            }
        }

        /// <summary>
        /// Получение объекта из набора по позиции
        /// </summary>
        /// <param name="position"></param>
        /// <returns></returns>
        public T? Get(int position)
        {
            if (position < Count && position >= 0) { return _places[position]; }
            return null;
             
        }
    }
}
